<template>
  <div class="games__list relative" style="z-index: 1;">
    <template v-for="game in games" :key="game.GameId">
      <div class="games-item" @click="handleClickGame(game)">
        <IconFavorite
          :gameData="game"
          :checkIsFavourite="checkIsFavourite"
          :redirectToLogin="redirectToLogin"
          :setAndUnsetGameToFavourite="setAndUnsetGameToFavourite"
          :ForMobile="true"/>
        <div class="games-item__img">
          <img v-lazy="isImageVersionExist(game.GameIconUrl)" />
        </div>
      </div>
    </template>
  </div>
  <game-select-overlay :drawer="drawer" :game="game" />
</template>

<script lang="ts">
import _ from "lodash";
import { defineComponent, PropType } from "vue";
import { onBeforeRouteLeave } from "vue-router";
import GameSelectOverlay from "./game-select-overlay.client.vue";
import { store } from "@/store";
import { IGameBsi } from "@/models/bsiGameList";

export default defineComponent({
  components: {
    GameSelectOverlay,
  },
  props: {
    games: {
      type: Array as PropType<Array<IGameBsi> | undefined>,
      required: true,
    },
  },
  setup() {
    const { game, drawer, handleClickGame } = useGameEntryOverlay();
    onBeforeRouteLeave(() => {
      drawer.value = false;
    });
    const isImageVersionExist = (imageURL: string): string => {
      if (_.includes(imageURL, "?v=")) {
        return imageURL;
      }
      return `${imageURL}?v=${store.state.imageVersion}`;
    };
    const {
      setAndUnsetGameToFavourite,
      checkIsFavourite,
      redirectToLogin,
    } = useAddToFavorite();
    return {
      game,
      drawer,
      handleClickGame,
      isImageVersionExist,
      setAndUnsetGameToFavourite,
      checkIsFavourite,
      redirectToLogin,
    };
  },
});
</script>
<style>
.games__list {
  display: flex;
  flex-wrap: wrap;
  gap: 0.5rem;
  margin-bottom: 40px;
}
.games__list > div {
  width: calc(50% - 0.3rem);
}
.games-item {
  width: 100%;
  max-width: unset;
  margin: unset;
  -webkit-box-sizing: border-box;
  box-sizing: border-box;
  background: rgba(209, 217, 230, 0.9);
  position: relative;
  -ms-flex-negative: 0;
  flex-shrink: 0;
  border-radius: 8px;
  background-repeat: no-repeat;
  background-position: center;
  background-size: 50%;
}
.games-item__img {
  height: 100%;
  padding-top: 67%;
  position: relative;
  overflow: hidden;
  border-radius: 8px;
  box-shadow: var(--box-shadow);
}
.games-item__img img {
  width: 100%;
  height: 100%;
  position: absolute;
  top: 0;
  left: 0;
  -o-object-fit: contain;
  object-fit: contain;
  border-radius: 8px;
}
</style>
